package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.CleavingAffix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.AABB;

public class ThunderstruckAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.ThunderstruckAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.ThunderstruckAffix::new));
  }
  
  public ThunderstruckAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237113_(fmt(getTrueLevel(rarity, 0.0F)));
    MutableComponent mutableComponent2 = Component.m_237113_(fmt(getTrueLevel(rarity, 1.0F)));
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isLightWeapon() && this.values.containsKey(rarity));
  }
  
  public void doPostAttack(ItemStack stack, LootRarity rarity, float level, LivingEntity user, Entity target) {
    if ((user.m_9236_()).f_46443_)
      return; 
    if (Apotheosis.getLocalAtkStrength((Entity)user) >= 0.98D) {
      List<Entity> nearby = target.m_9236_().m_6249_(target, (new AABB(target.m_20183_())).m_82400_(6.0D), (Predicate)CleavingAffix.cleavePredicate((Entity)user, target));
      for (Entity e : nearby)
        e.m_6469_(user.m_269291_().m_269333_(user), getTrueLevel(rarity, level)); 
    } 
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
